use day4::{CharGraph, CharGrid};

fn main() {
    let grid = match CharGrid::new("input.txt") {
        Ok(grid) => grid,
        Err(err) => {
            println!("Failed becuase of \n{err}");
            panic!("Program failed to execute")
        }
    };
    let graph = CharGraph::from(grid);
    println!("Solution to part 1 is {}", graph.count_xmas());
    println!("Solution to part 1 is {}", graph.count_part2_xmas());
}
