use day8::{get_antinode_count, CharGrid, Mode};

fn main() {
    let grid = match CharGrid::new("test_inputs/input.txt") {
        Ok(grid) => grid,
        Err(err) => {
            println!("Failed because of \n{err}");
            panic!("Program failed to execute")
        }
    };

    println!(
        "Solution to part 1 is {}",
        get_antinode_count(&grid, &Mode::Part1)
    );
    println!(
        "Solution to part 2 is {}",
        get_antinode_count(&grid, &Mode::Part2)
    );
}
